/*
 * @(#)gn.h	1.10 Aug.21,1993
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * (C) yamasita@omronsoft.co.jp
 */


#define VERSION	"1.10"
#define DATE	"Sep.1,1993"

/*  */

#define	BEL	0x7
#define	NL	'\n'
#define	ESC	0x1b
#define	DEL	0x7f
#define	SS2	0x8e

#ifdef	MSDOS
#define	SLASH_CHAR	'\\'
#define	SLASH_STR	"\\"
#else
#define	SLASH_CHAR	'/'
#define	SLASH_STR	"/"

#ifdef	USG
#	define	ENVUSR	"LOGNAME"
#	define	ENVUSR2	"USER"
#else
#	define	ENVUSR	"USER"
#	define	ENVUSR2	"LOGNAME"
#endif

#endif

#define	NEWSRC_LEN 1024
#define	PATH_LEN 256

#define	KEY_BUF_LEN	64
#define MAXNAME	256			/* max length of full name */
#define MAXHOSTNAME	256		/* max length of hostname */

/* ꥹ */
typedef	struct article	article_t;
struct article {
	article_t		*next;		/* ε */
	unsigned char	*from;		/* ݥȤ */
	unsigned char	*reference;	/* References: إåκǸ Message-ID */
	unsigned char	*message_id;	/* Message-ID */
	int				lines;		/* Կ */
	long			numb;		/* ֹ */
	int				flag;		/* 0:̤ 1:ɤ */
};

/* ֥ȥꥹ */
typedef	struct subject	subject_t;
struct	subject {
	subject_t		*next;		/*  subject ؤΥݥ */
	long			numb;		/* ο */
	unsigned char	*name;		/* Subject */
	article_t		*art;		/* ǽε */
	int				flag;		/* THREADED/NOTREONLY */
};
#define	THREADED	1
#define	NOTREONLY	2


/* ˥塼롼ץꥹ */
typedef	struct newsgroup	newsgroup_t;
struct newsgroup {
	newsgroup_t		*next;	/*  newsgroup_t ؤΥݥ */
	unsigned char	*name;	/* newsgroup ̾ */
	unsigned char	*newsrc;/* .newsrc ι */
	unsigned char	*desc;	/* ˥塼롼פ */
	long			first;	/* spool ˤǽεֹ */
	long			read;	/* ɤǸεֹ */
	long			last;	/* spool ˤǸεֹ */
	long			numb;	/* ̤ɤε */
	int				flag;	/* UNSUBSCRIBE,ACTIVE,NOARTICLE */
	subject_t		*subj;	/* ǽsubject */
};

#define	UNSUBSCRIBE	0x01	/* ɤʤ */
#define	ACTIVE		0x02	/* 롼פо¸ߤ */
#define	NOARTICLE	0x04	/* ̤ɵʤ */

newsgroup_t	*newsrc;	/* ˥塼롼ץꥹ */


/* Ǹɤ */
typedef struct last_art last_art_t;
struct last_art {
	unsigned char	tmp_file[PATH_LEN];		/* Ƥե */
	unsigned char	newsgroups[NNTP_STRLEN];	/* ˥塼롼 */
	unsigned char	from[NNTP_STRLEN];			/* Ƽ */
	unsigned char	date[NNTP_STRLEN];			/*  */
	unsigned char	references[NNTP_STRLEN];	/* References */
	unsigned char	xref[NNTP_STRLEN];			/* Xref */
};

last_art_t	last_art;	/* Ǹɤ */

#ifdef	SAVE_MEMORY
unsigned char newsrc_tmp_file[PATH_LEN];
#endif

/* ̤ɵ¿ϡǧ */
#define	ARTICLE_LIMIT 50
/* ΤƤ˻Ĥ */
#define	ARTICLE_LEAVE 50


#define	CONT	0
#define	QUIT	1
#define	END		-1
#define	ARTICLE_NOT_FOUND	-3
#define	FILE_WRITE_ERROR	-4
#define	CONNECTION_CLOSED	-5

#define	ON	1
#define	YES	1
#define	OFF	0
#define	NO	0

/* ѿ */

int	lines,columns;		/* ̤礭 */
int	(*redraw_func)();

int	internal_kanji_code;	/* gn δ */
int	spool_kanji_code;		/* NNTP δ */
int	mail_kanji_code;		/* ᥤδ */
int	process_kanji_code;		/* ڡ㡢ǥδ */
int	file_kanji_code;		/* ե˥֤δ */
int	display_kanji_code;		/* ̤δ */
#define JIS		1
#define EUC		2
#define SJIS	3

/* ץɤ˥塼סδɤؤѴ */
#define	kanji_tospool(sp,dp)		kanji_convert(process_kanji_code,sp,spool_kanji_code,dp)
/* ˥塼סδɤץɤؤѴ */
#define kanji_fromspool(sp,dp)	kanji_convert(spool_kanji_code,sp,process_kanji_code,dp)
/* ץɤᥤɤؤѴ */
#define kanji_tomail(sp,dp)	kanji_convert(process_kanji_code,sp,mail_kanji_code,dp)
/* ץɤեɤؤѴ */
#define kanji_tofile(sp,dp)	kanji_convert(process_kanji_code,sp,file_kanji_code,dp)
/* եɤץɤؤѴ */
#define kanji_fromfile(sp,dp)	kanji_convert(file_kanji_code,sp,process_kanji_code,dp)
/* ˥塼סδɤ ɤؤѴ */
#define kanji_spooltoint(sp,dp)	kanji_convert(spool_kanji_code,sp,internal_kanji_code,dp)

int	change;				/* newsrc ե饰 */

int	article_limit;		/* ̤ɵ¿ϡǧ */
int article_leave;		/* ΤƤ˻Ĥ */

unsigned char *pager;			/* ڡ */
int	return_after_pager;			/* ɽ Return ׵̵ͭ */
unsigned char *editor;			/* ǥ */
#ifndef	MSDOS
unsigned char *mailer;			/* ᥤ */
#endif

unsigned char *tmpdir;			/* $TMPDIR */
unsigned char *signature;		/* signature */
unsigned char *author_copy;		/* author copy */
unsigned char *savedir;			/* s ޥɤǵ򥻡֤ǥ쥯ȥ */
unsigned char *rcfile;			/* newsrc */

#ifdef	MSDOS
unsigned char *smtpserver;		/* smtp  */
#endif
unsigned char *hostname;		/* ۥ̾ */
unsigned char *nntpserver;		/* ˥塼 */
unsigned char *domainname;		/* ɥᥤ̾ */
unsigned char *organization;	/* ȿ̾ */
unsigned char *fullname;		/* Full Name */
unsigned char *usrname;			/* login name */
int	gnus_format;				/* 1:GNUS format  .newsrc ɤ߹ */
int	nsubject;					/* 1:ܸ쥵֥Ȥ */
int	description;				/* 1:˥塼롼פɽ */
int	kill_control;				/* ȥåɤ */
#define	KILL_CANCEL			1	/* cancel */
#define	KILL_IHAVE			2	/* ihave */
#define	KILL_SENDME			4	/* sendme */
#define	KILL_NEWGROUP		8	/* newgroup */
#define	KILL_RMGROUP		16	/* rmgroup */
#define	KILL_CHECKGROUPS	32	/* checkgroups */
#define	KILL_SENDSYS		64	/* sendsys */
#define	KILL_VERSION		128	/* version */
#define	JUNK_GROUP			1024	/* junk Ǥ Subject ǤϤʤ Newsgroups */

int genericfrom;				/* 1:From: ˥ۥ̾Ĥʤ */
int autolist;					/* 1:ƥ⡼ɤǤΥꥹɽưŪ˹Ԥʤ */

#ifdef PCNFS
#include "pcnfs.h"
#endif
